ChatSounds_Version = "0.10 (11200)"
ChatSounds_Player  = "player"
ChatSounds_Config  = {}

function ChatSounds_OnLoad()

	-- Register Variable Loading and Chat Events.
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("CHAT_MSG_GUILD")
	this:RegisterEvent("CHAT_MSG_OFFICER")
	this:RegisterEvent("CHAT_MSG_PARTY")
	this:RegisterEvent("CHAT_MSG_RAID")
	this:RegisterEvent("CHAT_MSG_RAID_LEADER")
	this:RegisterEvent("CHAT_MSG_BATTLEGROUND")
	this:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
	
	-- Register Slash Command.
	SLASH_CHATSOUNDS1 = "/chatsounds"
	SlashCmdList["CHATSOUNDS"] = ChatSoundsOptionsFrame_Show

end

function ChatSounds_InitConfig ( )

	ChatSounds_Player = UnitName("player") .. " of " .. GetCVar("realmName")

	if (not ChatSounds_Config) then
		ChatSounds_Config = {}
	end
	if (not ChatSounds_Config[ChatSounds_Player]) then
		ChatSounds_Config[ChatSounds_Player] = {}
		ChatSounds_Config[ChatSounds_Player].ForceWhispers          = true
	end
	if (not ChatSounds_Config[ChatSounds_Player].Incoming) then
		ChatSounds_Config[ChatSounds_Player].Incoming               = {}
		ChatSounds_Config[ChatSounds_Player].Incoming["GUILD"]      = "Kachink"
		ChatSounds_Config[ChatSounds_Player].Incoming["OFFICER"]    = "Link"
		ChatSounds_Config[ChatSounds_Player].Incoming["PARTY"]      = "Text1"
		ChatSounds_Config[ChatSounds_Player].Incoming["RAID"]       = "Text2"
		ChatSounds_Config[ChatSounds_Player].Incoming["WHISPER"]    = "Heart"
		ChatSounds_Config[ChatSounds_Player].Incoming["RAID_LEADER"]    = "Choo"
		ChatSounds_Config[ChatSounds_Player].Incoming["BATTLEGROUND"]    = "switchy"
		ChatSounds_Config[ChatSounds_Player].Incoming["BATTLEGROUND_LEADER"]    = "doublehit"
	end
	if (not ChatSounds_Config[ChatSounds_Player].Outgoing) then
		ChatSounds_Config[ChatSounds_Player].Outgoing               = {}
		ChatSounds_Config[ChatSounds_Player].Outgoing["GUILD"]      = "pop1"
		ChatSounds_Config[ChatSounds_Player].Outgoing["OFFICER"]    = "pop2"
		ChatSounds_Config[ChatSounds_Player].Outgoing["PARTY"]      = "pop1"
		ChatSounds_Config[ChatSounds_Player].Outgoing["RAID"]       = "pop1"
		ChatSounds_Config[ChatSounds_Player].Outgoing["WHISPER"]    = "TellMessage"
		ChatSounds_Config[ChatSounds_Player].Incoming["RAID_LEADER"]    = "pop2"
		ChatSounds_Config[ChatSounds_Player].Incoming["BATTLEGROUND"]    = "pop1"
		ChatSounds_Config[ChatSounds_Player].Incoming["BATTLEGROUND_LEADER"]    = "pop2"
	end

	-- Remove old config information.
	if (ChatSounds_Config[ChatSounds_Player].ForceWhisper) then
		ChatSounds_Config[ChatSounds_Player].ForceWhisper = nil
	end
	if (ChatSounds_Config[ChatSounds_Player].GuildEnabled) then
		ChatSounds_Config[ChatSounds_Player].GuildEnabled = nil
	end
	if (ChatSounds_Config[ChatSounds_Player].OfficerEnabled) then
		ChatSounds_Config[ChatSounds_Player].OfficerEnabled = nil
	end
	if (ChatSounds_Config[ChatSounds_Player].PartyEnabled) then
		ChatSounds_Config[ChatSounds_Player].PartyEnabled = nil
	end
	if (ChatSounds_Config[ChatSounds_Player].RaidEnabled) then
		ChatSounds_Config[ChatSounds_Player].RaidEnabled = nil
	end
	if (ChatSounds_Config[ChatSounds_Player].WhisperEnabled) then
		ChatSounds_Config[ChatSounds_Player].WhisperEnabled = nil
	end
end

function ChatSounds_OnEvent(event)

	if (event == "VARIABLES_LOADED") then

		ChatSounds_InitConfig ( );

		-- hook ChatFrame_OnEvent Function (needed for Whispers)
		ChatSounds_OldChatFrame_OnEvent = ChatFrame_OnEvent;
		ChatFrame_OnEvent = ChatSounds_NewChatFrame_OnEvent;

		-- ChatSounds are now loaded!
		DEFAULT_CHAT_FRAME:AddMessage("ChatSounds ".. ChatSounds_Version .. " are loaded.");

	elseif (string.sub (event, 1, 8) == "CHAT_MSG") then

		local msgtype = string.sub (event, 10)

		if (arg2 == UnitName ("player")) then
			ChatSounds_PlaySound (ChatSounds_Config[ChatSounds_Player].Outgoing[msgtype]);
		else
			ChatSounds_PlaySound (ChatSounds_Config[ChatSounds_Player].Incoming[msgtype]);
		end

	end
end

function ChatSounds_PlaySound (sound)

	if (not sound or not ChatSounds_Sound[sound]) then
		return 
	elseif (ChatSounds_Sound[sound].file) then
		PlaySoundFile (ChatSounds_Sound[sound].value)
	else
		PlaySound (ChatSounds_Sound[sound].value)
	end

end


-- New Hook function.  This one uses the old one!
function ChatSounds_NewChatFrame_OnEvent (event)

	if (event == "CHAT_MSG_WHISPER") then

		ChatEdit_SetLastTellTarget(this.editBox, arg2)

		if (this.tellTimer and (GetTime ( ) > this.tellTimer)) or 
		   (ChatSounds_Config[ChatSounds_Player].ForceWhispers) then
			ChatSounds_PlaySound (ChatSounds_Config[ChatSounds_Player].Incoming["WHISPER"])
		end

		this.tellTimer = GetTime ( ) + CHAT_TELL_ALERT_TIME
		FCF_FlashTab ( )

	elseif (event == "CHAT_MSG_WHISPER_INFORM") then

		ChatEdit_SetLastTellTarget(this.editBox, arg2)
		ChatSounds_PlaySound (ChatSounds_Config[ChatSounds_Player].Outgoing["WHISPER"])

	end

	ChatSounds_OldChatFrame_OnEvent (event);

end