local groupmap = {} -- Map chat message types to OptionFrame's Group Numbers
groupmap[1] = "GUILD"
groupmap[2] = "OFFICER"
groupmap[3] = "PARTY"
groupmap[4] = "RAID"
groupmap[5] = "WHISPER"
groupmap[6] = "RAID_LEADER"
groupmap[7] = "BATTLEGROUND"
groupmap[8] = "BATTLEGROUND_LEADER"

function ChatSoundsDropDown_OnLoad ( )
	UIDropDownMenu_Initialize (this, ChatSoundsDropDown_Init)
	UIDropDownMenu_SetSelectedID (this, 1, 0)
end

function ChatSoundsDropDown_Init ( )
	local sound = {}
	local i = 1

	for name, value in ChatSounds_Sound do
		sound[i] = name
		i = i + 1
	end

	table.sort (sound)

	do
		local entry = {}

		entry.text    = "None"
		entry.value   = nil
		entry.func    = ChatSoundsDropDown_OnClick
		entry.checked = false
		entry.owner   = this

		UIDropDownMenu_AddButton (entry)
	end

	for index, value in sound do
		local entry = {}

		entry.text    = value
		entry.value   = value
		entry.func    = ChatSoundsDropDown_OnClick
		entry.checked = false
		entry.owner   = this

		UIDropDownMenu_AddButton (entry)
	end
end

function ChatSoundsDropDown_OnClick ( )
	UIDropDownMenu_SetSelectedValue (UIDropDownMenu_GetCurrentDropDown ( ), this.value, 0);
end

function ChatSoundsOptionsFrame_OnLoad ( )
	this:RegisterEvent("VARIABLES_LOADED");
end

function ChatSoundsOptionsFrame_OnEvent (event)
	if (event == "VARIABLES_LOADED") then
		local that = this
		this = ChatMenu
		UIMenu_AddButton ("ChatSounds", nil, ChatSoundsOptionsFrame_Show)
		this = that	
	end
end

function ChatSoundsOptionsFrame_OnShow ( )
	for i = 1, 8 do
		local incoming = getglobal ("ChatSoundsOptionsFrameGroup"..i.."Incoming")
		local outgoing = getglobal ("ChatSoundsOptionsFrameGroup"..i.."Outgoing")

		UIDropDownMenu_SetSelectedValue (incoming, ChatSounds_Config[ChatSounds_Player].Incoming[groupmap[i]], 0)
		UIDropDownMenu_SetSelectedValue (outgoing, ChatSounds_Config[ChatSounds_Player].Outgoing[groupmap[i]], 0)		
	end

	ChatSoundsOptionsFrameForceWhispersCheckBox:SetChecked (ChatSounds_Config[ChatSounds_Player].ForceWhispers)
end

function ChatSoundsOptionsFrame_OnOkay ( )
	for i = 1, 8 do
		local incoming = getglobal ("ChatSoundsOptionsFrameGroup"..i.."Incoming")
		local outgoing = getglobal ("ChatSoundsOptionsFrameGroup"..i.."Outgoing")

		ChatSounds_Config[ChatSounds_Player].Incoming[groupmap[i]] = UIDropDownMenu_GetSelectedValue (incoming)
		ChatSounds_Config[ChatSounds_Player].Outgoing[groupmap[i]] = UIDropDownMenu_GetSelectedValue (outgoing)		
	end

	ChatSounds_Config[ChatSounds_Player].ForceWhispers = ChatSoundsOptionsFrameForceWhispersCheckBox:GetChecked ( )
end

function ChatSoundsOptionsFrame_OnCancel ( )
end

function ChatSoundsOptionsFrame_OnDefaults ( )
	for i = 1, 8 do
		local incoming = getglobal ("ChatSoundsOptionsFrameGroup"..i.."Incoming")
		local outgoing = getglobal ("ChatSoundsOptionsFrameGroup"..i.."Outgoing")

		UIDropDownMenu_SetSelectedValue (incoming, ChatSounds_Defaults.Incoming[groupmap[i]], 0)
		UIDropDownMenu_SetSelectedValue (outgoing, ChatSounds_Defaults.Outgoing[groupmap[i]], 0)	
	end

	ChatSoundsOptionsFrameForceWhispersCheckBox:SetChecked (ChatSounds_Defaults.ForceWhispers)
end

function ChatSoundsOptionsFrame_Show ( )
	ChatSoundsOptionsFrame:Show ( )
end